package org.papervision3d.core.proto
{
    import org.papervision3d.core.*;
    import org.papervision3d.core.geom.*;
    import org.papervision3d.core.math.*;
    import org.papervision3d.core.draw.*;
    import org.papervision3d.core.render.*;
    import org.papervision3d.core.material.*;
    
    public class Light3D extends Object3D implements ILightProvider, IPrimitiveProvider
    {
        public var color:int;
        public var ambient:Number;
        public var diffuse:Number;
        public var specular:Number;

        public function Light3D(color:int, ambient:Number, diffuse:Number, specular:Number, distance:Number = 30)
        {
            this.color = color;
            this.ambient = ambient * distance * distance;
            this.diffuse = diffuse * distance * distance;
            this.specular = specular * distance * distance;
        }

        public function light(transform:Matrix3D, consumer:ILightConsumer):void
        {
            consumer.pointLight(transform, color, ambient, diffuse, specular);
        }

        public function primitives(projection:Projection, consumer:IPrimitiveConsumer):void
        {
            var v:Vertex3D = new Vertex3D(0, 0, 0);
            var vp:Vertex2D = v.project(projection);
            if (!vp.visible)
                return;

            var tri:DrawTriangle = new DrawTriangle();
            tri.v0 = new Vertex2D(vp.x + 3, vp.y + 2, vp.z);
            tri.v1 = new Vertex2D(vp.x - 3, vp.y + 2, vp.z);
            tri.v2 = new Vertex2D(vp.x, vp.y - 3, vp.z);
            tri.calc();
            tri.source = this;
            tri.projection = projection;
            tri.material = new ColorMaterial(color);
            consumer.primitive(tri);

        }

    }
}
