package org.papervision3d.core.proto
{
    import flash.display.Sprite;
    import flash.utils.getTimer;
    import flash.utils.Dictionary;
    //import flash.geom.*;
    //import flash.display.*;
    
    import org.papervision3d.core.draw.*;
    import org.papervision3d.core.proto.*;
    import org.papervision3d.core.geom.*;
    import org.papervision3d.core.render.*;
    
    // The SceneObject3D class is the base class for all scenes.
    // A scene is the place where objects are placed, it contains the 3D environment.
    // The scene manages all objects rendered in Papervision3D. It extends the ObjectContainer3D class to arrange the display objects.
    // SceneObject3D is an abstract base class; therefore, you cannot call SceneObject3D directly.
    public class Scene3D extends ObjectContainer3D
    {
        // The Sprite that you draw into when rendering.
        public var container:Sprite;
    
        // An object that contains total and current statistics.
        //   points
        //   polys
        //   triangles
        //   performance
        //   rendered
        public var stats:Object;
    
        // The SceneObject3D class lets you create scene classes.
        // @param container The Sprite that you draw into when rendering. If not defined, each object must have it's own private container.
        public function Scene3D(...objects)
        {
            //if (container)
            //    this.container = container;
            //else
                this.container = new Sprite();
    
            this.stats = new Object();
            this.stats.points = 0;
            this.stats.polys = 0;
            this.stats.triangles = 0;
            this.stats.performance = 0;
            this.stats.rendered = 0;

            for each (var object:Object3D in objects)
                addChild(object);
        }

        public function clear():void
        {
            container.graphics.clear();
        }
/*
        public function findHit(camera:Camera3D, x:Number, y:Number):OldFindHitCallback
        {
            var callback:OldFindHitCallback = new OldFindHitCallback(x, y, 0);
            renderCamera(camera, callback);
            return callback;
        }

        public function findNearest(camera:Camera3D, x:Number, y:Number):OldFindHitCallback
        {
            var callback:OldFindHitCallback = new OldFindHitCallback(x, y);
            renderCamera(camera, callback);
            return callback;
        }
*/
        protected var clip:Clipping;

        public function render(camera:Camera3D, ...renderers):void
        {
            // updateBitmaps

            container.graphics.clear();

            if (renderers.length == 0)
                renderers.push(new BasicRenderer());

            for each (var renderer:IRenderer in renderers)
                renderer.render(this, camera, container, clip || Clipping.screen(container));
        }

        public function updateTime(time:int = -1):void
        {
            if (time == -1)
                time = getTimer();
            traverse(new TickTraverser(time));
        }

        public function updateLight():void
        {
            //traverse(new LightTraverser(new ClearLight(), null));
            //traverse(new LightSourceTraverser(this));
        }

    }
}
